import { Observable } from 'rxjs';
import type NodeWebSocket from 'ws';
export interface MessageDeserializer<T> {
    (event: MessageEvent | NodeWebSocket.MessageEvent): T;
}
interface Options<T> {
    protocols?: string | string[];
    clientOptions?: NodeWebSocket.ClientOptions;
    deserializer?: MessageDeserializer<T>;
    debug?: boolean;
}
export declare class RxWebSocket<DeserializedMessage> {
    #private;
    constructor(url: string, { protocols, clientOptions, deserializer, debug }: Options<DeserializedMessage>);
    get active(): boolean;
    get message(): Observable<DeserializedMessage>;
    send(data: string): Observable<DeserializedMessage>;
}
export {};
